/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.rank.controller;

import lombok.AllArgsConstructor;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.tool.api.R;
import org.springblade.modules.guosen.rank.service.RankService;
import org.springframework.web.bind.annotation.*;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-06-09
 */
@RestController
@AllArgsConstructor
@RequestMapping("rank")
public class RankController extends BladeController {

	private RankService rankService;


	@GetMapping("/delProductKey")
	public R addScore(String key) {
		rankService.delProductKey(key);
		return R.data(true);
	}
	/**
	 * 详情
	 */
	@GetMapping("/addScore")
	public R addScore(String activityId,String valueId,Double score,Integer type) {
		rankService.addScore(activityId,valueId,score,type);
		return R.data(true);
	}

	@GetMapping("/userRank")
	public R userRank(String activityId,String valueId,Integer type) {
		return R.data(rankService.rank(activityId,valueId,type));
	}

	@GetMapping("/reverseZRankWithRank")
	public R reverseZRankWithRank(String activityId,long start, long end,Integer type) {
		return R.data(rankService.reverseZRankWithRank(activityId,start,end,type));
	}

	@GetMapping("/rankWithScore")
	public R rankWithScore(String activityId,Integer start, Integer end,Integer type) {
		return R.data(rankService.rankWithScore(activityId, start, end, type));
	}



}
